#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <rockchip/rockchip_drm.h>

int main(int arc, char **argv)
{
	int fd, ret = 0;
	DrmBuffer *cma = NULL;
	DrmBuffer *drm = NULL;
	
	

	fd = RockchipDrmOpen();
	if(fd < 0)
		return fd;
	
	cma = RockchipCmaAlloc(fd, V4L2_PIX_FMT_NV12, 1920, 1080);
	if(!cma) {
		ret = -ENOMEM;
		goto exit;
	}

	drm = RockchipDrmAlloc(fd, V4L2_PIX_FMT_RGB24, 1920, 1080);
	if(!drm) {
		ret = -ENOMEM;
		goto exit;
	}

	printf("DRM: alloc size 0x%lx, size_align 0x%lx, virtual addr %p\n", drm->size, drm->size_align, drm->virt);
	printf("CMA: alloc size 0x%lx, size_align 0x%lx, virtual addr %p, physical addr 0x%lx\n",
		cma->size, cma->size_align, cma->virt, cma->phys);

	/* TODO: cma and drm buffer operation */

exit:
	if(drm)
		RockchipDrmFree(fd, drm);	
	if(cma)
		RockchipCmaFree(fd, cma);	

	RockchipDrmClose(fd);
	return ret;
}
